unit shell;

interface

const
	Black = 0;
	Blue = 1;
	Green = 2;
	Cyan = 3;
	Red = 4;
	Magenta = 5;
	Brown = 6;
	LightGray = 7;
	DarkGray = 8;
	LightBlue = 9;
	LightGreen = 10;
	LightCyan = 11;
	LightRed = 12;
	LightMagenta = 13;
	Yellow = 14;
	White = 15;

	F1=59;
	F2=60;
	F3=61;
	F4=62;
	F5=63;
	F6=64;
	F7=65;
	F8=66;
	F9=67;
	F10=68;
	F11=87;
	F12=88;
	Enter=28;
	Crtl=29;
	Alt=56;
	BkSpc=14;
	Space=57;
	Shift=42;
	CapsLock=58;
	up=72 ;
	left=75;
	right=77;
	down=80 ;

	tblchar : array [1..57] of char=
	   ('0','1','2','3','4','5','6','7','8','9','0','?','=','0',' ',
	   'Q','W','E','R','T','Y','U','I','O','P','[',']','0','0',
	   'A','S','D','F','G','H','J','K','L',' ','{','}','0','0',
	   'Z','X','C','V','B','N','M',',','.','/','0','*','0',' ');

var
	Screen: pchar =  PChar ($B8000);
	CursorX, CursorY: integer;
	Color: char;
	Background: integer = 0;
	backspace: array [0..4000] of integer;
	Command: PChar;
	e: integer = 0;
	keyp: array[0..127] of Boolean;
	address: Word;
	cmd: integer =0;

procedure ClearScreen;
procedure PrintStr(text: PChar);
procedure SetColor(txt,back:integer);
procedure SetXY(x,y: integer);
procedure Command2;
procedure Scroll;
procedure PrintKey(ch: Char);
procedure keys;

procedure outportb(port, zn:word);external 'kernel.o';
function inportb(port:word):byte;external 'kernel.o';
procedure reset;external 'kernel.o';

implementation

procedure keys;
var
	b: Byte;
	key: array[0..127] of Boolean; 
	z: integer=2;
begin
	b:= inportb($60); //czytamy z portu
	if b>$7F then
		key[b xor $80]:= False 
	else
		key[b]:= True;  
//BACKSPACE
	if key[BkSpc] then //jezeli nacisniety backspace
	begin 
		if keyp[BkSpc]<>True then
		begin
			address:=CursorX*2+CursorY*160;
			if backspace[address-2] = 1 then //jezeli zostalo wpisane z klawiatury
			begin
				CursorX := CursorX - 1; //cofamy kursor
				Screen[CursorX*2+CursorY*160]:=#0; //usuwamy znak
				e:=e-1; //cofamy pozycje komendy
				Command[e]:=#0; //usuwamy znak z komendy
				SetXY(CursorX,CursorY); //ustawiamy kursor
			end;
			keyp[BkSpc]:=True;
		end;
	end 
	else
	begin
		keyp[BkSpc]:=False;
	end;
//ENTER
	if key[enter] then //jezeli enter
	begin 
		if keyp[enter]<>True then
		begin
			Command2; //wykonujemy polecenie
			keyp[enter]:=True;
		end;
	end 
	else
	begin
		keyp[enter]:=False;
	end;

	repeat
		if key[z] then //jezeli cos innego
		begin
			if keyp[z]<>True then
			begin 
				PrintKey(tblchar[z]); //piszemy na ekranie
				Command[e]:=tblchar[z]; //dodajemy do komendy
				e+=1;
				keyp[z]:=True; 
			end;
		end
		else
			keyp[z]:=False;
		z+=1;
	until z=127;
	outportb($20, $20);
end;

procedure PrintKey(ch: Char);
var
	address: Word;
begin
	if (CursorX > 79) or (ch = #13) then
		SetXY(0, CursorY+1)
	else
	if ch = #10 then
		SetXY(CursorX, CursorY+1)
	else
	if CursorY > 24 then
	begin
		SetXY(CursorX, 24);
		Scroll;
	end;

	address:= CursorX*2 + CursorY * 160;
	Screen[address]:= ch;
	Screen[address+1]:= color;	
	backspace[address]:=1;
	backspace[address+1]:=1;
	SetXY(CursorX+1, CursorY);
end;


procedure ClearScreen;
var
	i: integer;
begin
	for i:=0 to 2000 do
	begin
		Screen[i*2]:=#0;
		Screen[i*2-1]:=char(white);
	end;
end;

procedure PrintStr(text: PChar);
var
	address: Word;
	i: integer;
begin
	i:=0;
	if (CursorX > 79) or (text[i] = #13) then 
	begin
		SetXY(0, CursorY+1);
	end 
	else
	begin
		if (text[i] = #10) then
		begin
			SetXY(CursorX, CursorY+1);
		end
	else
	begin
		if (CursorY > 24) then
			begin
				SetXY(CursorX, 24);
				Scroll;
			end;

	repeat
		address:= CursorX*2 + CursorY * 160;
		Screen[address]:= text[i];
		Screen[address+1]:= color;	
		backspace[address]:=0;
		backspace[address+1]:=0;
		SetXY(CursorX+1, CursorY);
		i:=i + 1;
	until text[i] = #0

		end;
	end;
end;

procedure SetColor(txt,back: integer);
begin
	color:=char(txt+back*16);
end;

procedure SetXY(x,y: integer);
var
	temp: integer;
begin
	CursorX := x;
	CursorY := y;
	temp:=y*80+x;
	outportb($3D4, 14);
	outportb($3D5, temp>>8);
	outportb($3D4, 15);
	outportb($3D5, temp);
end;

procedure Command2;
var 
	pol : integer= 0;
	a:integer;
	i : integer = 0;
	q : pchar;
	b:integer=0;
	wynik: pchar;
	ii:integer =0;
begin
	cmd := 0;
	if (Command[0]='E') and (Command[1]='X') and (Command[2]='I') and (Command[3]='T') and (Command[4]=#0) then
	begin // exit
		reset;
	end
	else
	if (Command[0]='H') and (Command[1]='E') and (Command[2]='L') and (Command[3]='P') and (Command[4]=#0) then
	begin // help
		PrintStr(#13);
		PrintStr('EXIT - resetuje komputer');
		PrintStr(#13);
		PrintStr('HELP - wyswietla pomoc');
			end
	else
	begin
		PrintStr(#13);
		PrintStr('Polecenie "');
		PrintStr(Command);
		PrintStr('" nie zostalo odnalezione.');
	end;

	e:=0;
	PrintStr(#13);
	SetColor(LightGray,Black);
	PrintStr('>');
	SetColor(White,Black);
	repeat //czyszczenie zmiennej "Command"
		Command[pol]:=#0;
		pol+=1;
	until pol=100;
end;

procedure Scroll;
var
	address : word;
begin
	for address:=0 to 1920 do
	begin
		Screen[address*2] := Screen[address*2+160];
		Screen[address*2+1] := Screen[address*2+1+160];
	end;

	for address:=1921 to 2000 do
	begin
		Screen[address*2]:=#0;
		Screen[address*2+1]:=char(15); 
	end;		
end;

end.